{ Error messages
 (C) 2005-2012, Andreas Berg. All Rights Reserved. }
unit _error;

interface

uses
 _common;

var
 ErrorCount        : TDefValue;
 WarningCount      : TDefValue;
 IsErr             : boolean;
 IsSysErr          : boolean;

procedure InitErrors;

procedure SysError(s: string);
procedure SysWarning(s: string);

procedure ErrorMsg(s: string);
procedure WarningMsg(s: string);

procedure FatalError(s: string);
procedure FatalWarning(s: string);

implementation

uses
 SysUtils, _source, _emit;

procedure InitErrors;
begin
   ErrorCount:= 0;
   WarningCount:= 0;
   IsErr:= false;
   IsSysErr:= false;
   {frmBuild.Label14.Caption:= '0 / 0';}
end;



procedure SysError(s: string);
begin
   If not IsErr then begin
      EmitLn(appName + ' (ERROR): ' + s);
      IsErr:= true;
   end;
   IsSysErr:= true;
end;

procedure SysWarning(s: string);
begin
   EmitLn(appName + ' (WARNING): ' + s);
end;



procedure ErrorMsg(s: string);
var
 ss                : string;
begin
   If not IsErr then begin
      ss:= 'ERROR: ' + Source[CurLevel].FileName + ': ' + s;
      ss:= ss + ' Line: [' + IntToStr(Source[CurLevel].CurLine) + ']';
      EmitLn(ss);
      IsErr:= true;
      Inc(ErrorCount);
      {frmBuild.Label14.Caption:= IntToStr(ErrorCount) + ' / '+
       IntToStr(WarningCount);}
   end;
end;

procedure WarningMsg(s: string);
var
 ss                : string;
begin
   ss:= 'WARNING: ' + Source[CurLevel].FileName + ': ' + s;
   ss:= ss + ' Line: [' + IntToStr(Source[CurLevel].CurLine) + ']';
   EmitLn(ss);
   Inc(WarningCount);
   {frmBuild.Label14.Caption:= IntToStr(ErrorCount) + ' / '+
    IntToStr(WarningCount);}
end;



procedure FatalError(s: string);
begin
   EmitLn('FATAL ERROR: ' + s);
   IsErr:= true;
   Inc(ErrorCount);
   {frmBuild.Label14.Caption:= IntToStr(ErrorCount) + ' / '+
    IntToStr(WarningCount);}
end;

procedure FatalWarning(s: string);
begin
   EmitLn('FATAL WARNING: ' + s);
   Inc(WarningCount);
   {frmBuild.Label14.Caption:= IntToStr(ErrorCount) + ' / '+
    IntToStr(WarningCount);}
end;

end.
