{ Scanner
 (C) 2005-2012, Andreas Berg. All Rights Reserved. }
unit _scanner;

interface

function IsBlank(c: char): boolean;
function IsXChar(c: char): boolean;
function IsBin(c: char): boolean;
function IsOctal(c: char): boolean;
function IsDigit(c: char): boolean;
function IsHexAlpha(c: char): boolean;
function IsHex(c: char): boolean;
function IsAlpha(c: char): boolean;
function IsAlnum(c: char): boolean;
function IsNameChar(c: char): boolean;
function IsName(c: char): boolean;
function IsAddOp(c: char): boolean;
function IsMulOp(c: char): boolean;
function IsStdOpr(c: char): boolean;
function IsNumPrefix(c: char): boolean;

implementation

function IsBlank(c: char): boolean;
begin
   IsBlank:= (c = ' ') or (c = #9);
end;

function IsXChar(c: char): boolean;
begin
   IsXChar:= (UpCase(c) = 'X');
end;

function IsBin(c: char): boolean;
begin
   IsBin:= (c = '0') or (c = '1');
end;

function IsOctal(c: char): boolean;
begin
   IsOctal:= (c in ['0'..'7']);
end;

function IsDigit(c: char): boolean;
begin
   IsDigit:= (c in ['0'..'9']);
end;

function IsHexAlpha(c: char): boolean;
begin
   IsHexAlpha:= (UpCase(c) in ['A'..'F']);
end;

function IsHex(c: char): boolean;
begin
   IsHex:= (IsDigit(c)) or (IsHexAlpha(c));
end;

function IsAlpha(c: char): boolean;
begin
   IsAlpha:= (UpCase(c) in ['A'..'Z']);
end;

function IsAlnum(c: char): boolean;
begin
   IsAlnum:= (IsDigit(c)) or (IsAlpha(c));
end;

function IsNameChar(c: char): boolean;
var
 isNC              : boolean;
begin
   isNC:= false;
   if IsAlpha(c) then begin
      isNC:= true;
   end else begin
      if c = '_' then isNC:= true;
      if c = '.' then isNC:= true;
      if c = '?' then isNC:= true;
      if c = '@' then isNC:= true;
      if c = '~' then isNC:= true;
   end;
   IsNameChar:= isNC;
end;

function IsName(c: char): boolean;
begin
   IsName:= (IsDigit(c)) or (IsNameChar(c));
end;

function IsAddOp(c: char): boolean;
begin
   IsAddOp:= (c in ['+', '-']);
end;

function IsMulOp(c: char): boolean;
begin
   IsMulOp:= (c in ['*', '/']);
end;

function IsStdOpr(c: char): boolean;
begin
   IsStdOpr:= (c in ['+', '-', '*', '/']);
end;

function IsNumPrefix(c: char): boolean;
begin
   IsNumPrefix:= (c = '%') or (c = '');
end;

end.
